<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\CrmModoReceberInfoService;

class CrmModoReceberInfoController
{
    protected $CrmModoReceberInfoService;

    use TResponse;

    public function __construct(CrmModoReceberInfoService $CrmModoReceberInfoService)
    {
        $this->CrmModoReceberInfoService = $CrmModoReceberInfoService;
    }

    public function getReceiveInfo()
    {
        try {
            $data = $this->CrmModoReceberInfoService->getReceiveInfoService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveReceiveInfo(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $this->CrmModoReceberInfoService->saveReceiveInfoService($rows);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteReceiveInfo(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $this->CrmModoReceberInfoService->deleteReceiveInfoService($rows);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
