<?php

namespace CRM\Controller;

use Zeedhi\Framework\DTO\Request;
use CRM\Traits\TResponse;
use CRM\Service\Ger10120SegmentoMercadoService;

class Ger10120SegmentoMercadoController
{
    protected $SegmentoMercadoService;

    use TResponse;

    public function __construct(Ger10120SegmentoMercadoService $SegmentoMercadoService)
    {
        $this->SegmentoMercadoService = $SegmentoMercadoService;
    }

    public function getMarketSegment()
    {
        try {
            $data = $this->SegmentoMercadoService->getMarketSegmentService();
            $this->sendResponse($data, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function saveMarketSegment(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $this->SegmentoMercadoService->saveMarketSegmentService($rows);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function deleteMarketSegment(Request $request)
    {
        try {
            $rows = $request->getParameters();
            $this->SegmentoMercadoService->deleteMarketSegmentService($rows);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
