<?php

namespace CRM\Factory;

use CRM\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class CrmClassificacaoDeOportunidadeFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getClassificationOpportunityFactory()
    {

        $sql = "SELECT * FROM CRM_CLASSOPORTUNI ORDER BY NMCLASSOPORT ASC";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function saveClassificationOpportunityFactory($params)
    {
        $sql = "INSERT INTO CRM_CLASSOPORTUNI (
            NRSEQCLASSOPORT,  NMCLASSOPORT,   IDATIVO,         NRORG,
            NRORGINCLUSAO,    NRORGULTATU,    CDOPERINCLUSAO,
            CDOPERULTATU,     DTINCLUSAO,     DTULTATU
        )
        VALUES (
            :NRSEQCLASSOPORT,  :NMCLASSOPORT,  :IDATIVO,        :NRORG,
            :NRORGINCLUSAO,    :NRORGULTATU,   :CDOPERINCLUSAO,
            :CDOPERULTATU,     SYSDATE,        SYSDATE
        )";

        $this->connection->executeStatement($sql, $params);
    }

    public function updateClassificationOpportunityFactory($params)
    {
        $sql = "UPDATE CRM_CLASSOPORTUNI
        SET
            NMCLASSOPORT = :NMCLASSOPORT,
            IDATIVO = :IDATIVO,
            NRORGINCLUSAO = :NRORGINCLUSAO,
            NRORGULTATU = :NRORGULTATU,
            CDOPERINCLUSAO = :CDOPERINCLUSAO,
            CDOPERULTATU = :CDOPERULTATU,
            DTINCLUSAO = :DTINCLUSAO,
            DTULTATU = SYSDATE
        WHERE
            NRSEQCLASSOPORT = :NRSEQCLASSOPORT
            AND NRORG = :NRORG;";

        $this->connection->executeStatement($sql, $params);
    }

    public function deleteClassificationOpportunityFactory($params)
    {
        $sql = "DELETE 
                FROM CRM_CLASSOPORTUNI
                WHERE NRSEQCLASSOPORT IN (" . $params . ")";

        $this->connection->executeStatement($sql);
    }
}
