<?php

namespace CRM\Factory;

use CRM\Traits\TQuery;
use Doctrine\ORM\EntityManager;

class CrmEnderecoFactory
{
    use TQuery;

    protected $connection;

    protected $entityManager;

    public function __construct(EntityManager $entityManager)
    {
        $this->connection = $entityManager->getConnection();
        $this->entityManager = $entityManager;
    }

    public function getPaisFactory()
    {

        $sql = "SELECT PAIS.* FROM PAIS ORDER BY CASE WHEN UPPER(NMPAIS) = 'BRASIL' THEN 0 ELSE 1 END, NMPAIS";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }

    public function getEstadoFactory($params)
    {
        $cdPaises = implode(',', $params);
        $sql = "SELECT *
                FROM ESTADO
                WHERE CDPAIS = ($cdPaises)";

        return $this->createAndExecuteQueryAndBuildResponseData($this->entityManager, $sql);
    }
}
