<?php

namespace CRM\Service;

use CRM\Factory\CrmClassificacaoParceiroFactory;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Doctrine\ORM\EntityManager;

class CrmClassificacaoParceiroService {

    protected $TipoDeAtividadeFactory;
    protected $environment;
    protected $newCode;
    protected $connection;

    public function __construct(Environment $environment, NewCode $newCode, EntityManager $entityManager, CrmClassificacaoParceiroFactory $CrmClassificacaoParceiroFactory)
    {
        $this->CrmClassificacaoParceiroFactory       = $CrmClassificacaoParceiroFactory;
        $this->environment                           = $environment;
        $this->newCode                               = $newCode;
        $this->connection                            = $entityManager->getConnection();
    }

    public function getRankingPartnerService () {

        return $this->CrmClassificacaoParceiroFactory->getRankingPartnerFactory();

    }

    public function saveNewRankingPartnerService ($row) {
       
        $nrorg = $this->environment->getNrOrg();
        $cdoperador = $this->environment->getCdOperador();
        $this->connection->beginTransaction();
        try {
            foreach ($row["DRG"] as $rows) {

                if ($rows["NRTPCLASSIFICAPARC"] == 0) {

                    $rows["NRTPCLASSIFICAPARC"] = $this->newCode->getCodeByTableName("TIPOCLASSIFICAPARC", $nrorg, 1, 10, true);
                   
                    $params = array(
                    "NRTPCLASSIFICAPARC"    => $rows["NRTPCLASSIFICAPARC"],
                    "NMCLASSIFICAPARC"      => $rows["NMCLASSIFICAPARC"],
                    "NRORG"                 => $nrorg,
                    "NRORGINCLUSAO"         => $nrorg,
                    "NRORGULTATU"           => $nrorg,
                    "CDOPERINCLUSAO"        => $cdoperador,
                    "CDOPERULTATU"          => $cdoperador
                  );
                  
                  $this->CrmClassificacaoParceiroFactory->insertNewRankingPartnerFactory($params);

                } else {
                  
                  $params = array(
                    "NRTPCLASSIFICAPARC"    => $rows["NRTPCLASSIFICAPARC"],
                    "NMCLASSIFICAPARC"      => $rows["NMCLASSIFICAPARC"],
                    "NRORG"                 => $nrorg,
                    "NRORGINCLUSAO"         => $nrorg,
                    "NRORGULTATU"           => $nrorg,
                    "CDOPERINCLUSAO"        => $cdoperador,
                    "CDOPERULTATU"          => $cdoperador
                  );
                  
                  $this->CrmClassificacaoParceiroFactory->updateNewRankingPartnerFactory($params);

                }
            }
            $this->connection->commit();
        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
          }
        }
    public function deleteRankingPartnerService ($rows) {
      
      $this->connection->beginTransaction();
      $nrorg = $this->environment->getNrOrg();
      try {
        foreach ($rows["DRGS"] as $key => $row) {
          
          $params = array(
            "NRTPCLASSIFICAPARC" => $row,
            "NRORG" => $nrorg
          );

          $this->CrmClassificacaoParceiroFactory->deleteRankingPartnerFactory($params);
          
        }

        $this->connection->commit();

        } catch (\Exception $e) {
            $this->connection->rollback();
            throw $e;
        }
    }
}